"""New model

Revision ID: 41d541a8680b
Revises: 782f9ab841c7
Create Date: 2022-02-09 12:26:04.881697+01:00

"""
import sqlalchemy as sa
import uuid
from alembic import op
from enum import Enum
from sqlalchemy import orm
from sqlalchemy.dialects import postgresql
from sqlalchemy.orm import DeclarativeMeta, declarative_base

Base: DeclarativeMeta = declarative_base()

# revision identifiers, used by Alembic.
revision = "41d541a8680b"
down_revision = "782f9ab841c7"
branch_labels = None
depends_on = None


class Status(str, Enum):
    ACTIVE = "ACTIVE"
    INACTIVE = "INACTIVE"


class Rights(str, Enum):
    VIEWER = "VIEWER"
    EDITOR = "EDITOR"
    OWNER = "OWNER"


class Form(Base):
    __tablename__ = "form"

    sid = sa.Column(
        sa.Integer,
        sa.Sequence("form_sid_seq", metadata=Base.metadata),
        primary_key=True,
        index=True,
    )
    id = sa.Column(postgresql.UUID(as_uuid=True), nullable=False, index=True)
    name = sa.Column(sa.String(255), index=True, nullable=False)
    slug = sa.Column(sa.String(255), index=True, nullable=False)
    status = sa.Column(sa.Enum(Status), nullable=False)
    form = sa.Column(sa.JSON)
    config = sa.Column(sa.JSON, nullable=True)
    creator_organization_uuid = sa.Column(postgresql.UUID(as_uuid=True), nullable=False)
    publish_date = sa.Column(sa.Date, nullable=True)
    public = sa.Column(sa.BOOLEAN, nullable=False, default=False)


class FormManagement(Base):
    __tablename__ = "form_management"
    default_sort_field = "name"

    sid = sa.Column(sa.Integer, primary_key=True, index=True)
    id = sa.Column(
        postgresql.UUID(as_uuid=True),
        nullable=False,
        index=True,
        default=uuid.uuid4,
    )
    form_details_sid = sa.Column(sa.Integer, sa.ForeignKey("form_details.sid"), nullable=False)
    form_details = sa.orm.relationship("FormDetails")
    name = sa.Column(sa.String(255), index=True, nullable=False)
    slug = sa.Column(sa.String(255), index=True, nullable=False)
    config = sa.Column(sa.JSON, nullable=True)
    publish_date = sa.Column(sa.Date, nullable=True)
    status = sa.Column(sa.Enum(Status), nullable=False)
    organization_uuid = sa.Column(postgresql.UUID(as_uuid=True), nullable=False)
    organization_name = sa.Column(sa.String(), nullable=False)
    rights = sa.Column(sa.Enum(Rights), nullable=False)


class FormDetails(Base):
    __tablename__ = "form_details"
    default_sort_field = "creator_organization_name"

    sid = sa.Column(
        sa.Integer,
        sa.Sequence("form_details_sid_seq", metadata=Base.metadata),
        primary_key=True,
        index=True,
    )
    id = sa.Column(
        postgresql.UUID(as_uuid=True),
        nullable=False,
        index=True,
    )
    form = sa.Column(sa.JSON)
    public = sa.Column(sa.BOOLEAN, nullable=False, default=False)


def upgrade():
    """Upgrade"""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "form_details",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column("id", postgresql.UUID(as_uuid=True), nullable=False),
        sa.Column("form", sa.JSON(), nullable=True),
        sa.Column("public", sa.BOOLEAN(), nullable=False),
        sa.PrimaryKeyConstraint("sid"),
    )
    op.create_index(op.f("ix_form_details_id"), "form_details", ["id"], unique=False)
    op.create_index(op.f("ix_form_details_sid"), "form_details", ["sid"], unique=False)
    op.create_table(
        "form_management",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column("id", postgresql.UUID(as_uuid=True), nullable=False),
        sa.Column("form_details_sid", sa.Integer(), nullable=False),
        sa.Column("name", sa.String(length=255), nullable=False),
        sa.Column("slug", sa.String(length=255), nullable=False),
        sa.Column("config", sa.JSON(), nullable=True),
        sa.Column(
            "status",
            postgresql.ENUM("ACTIVE", "INACTIVE", name="status", create_type=False),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("publish_date", sa.Date(), nullable=True),
        sa.Column("organization_uuid", postgresql.UUID(as_uuid=True), nullable=False),
        sa.Column("organization_name", sa.String(), nullable=False),
        sa.Column(
            "rights",
            postgresql.ENUM(name="rights", create_type=False),
            nullable=False,
        ),
        sa.ForeignKeyConstraint(
            ["form_details_sid"],
            ["form_details.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
    )
    op.create_index(
        op.f("ix_form_management_name"),
        "form_management",
        ["name"],
        unique=False,
    )
    op.create_index(op.f("ix_form_management_id"), "form_management", ["id"], unique=False)
    op.create_index(
        op.f("ix_form_management_sid"),
        "form_management",
        ["sid"],
        unique=False,
    )
    op.create_index(
        op.f("ix_form_management_slug"),
        "form_management",
        ["slug"],
        unique=False,
    )

    op.create_unique_constraint(
        constraint_name="uc_name_organization_uuid",
        table_name="form_management",
        columns=["name", "organization_uuid"],
    )

    op.create_unique_constraint(
        constraint_name="uc_slug_organization_uuid",
        table_name="form_management",
        columns=["slug", "organization_uuid"],
    )

    # Now migrate data to new tables
    bind = op.get_bind()
    session = orm.Session(bind=bind)
    forms = bind.execute(sa.select(Form)).fetchall()
    for form in forms:
        form_db = FormDetails(id=form.id, form=form.form, public=form.public)
        session.add(form_db)
        session.commit()

        session.add(
            FormManagement(
                form_details=form_db,
                name=form.name,
                slug=form.slug,
                config=form.config,
                status=form.status,
                publish_date=form.publish_date,
                organization_uuid=form.creator_organization_uuid,
                organization_name="Exxellence",
                rights=Rights.OWNER,
            )
        )
        session.commit()

    # Now drop old tables
    op.drop_index("ix_shared_with_sid", table_name="shared_with")
    op.drop_table("shared_with")
    op.drop_index("ix_form_id", table_name="form")
    op.drop_index("ix_form_name", table_name="form")
    op.drop_index("ix_form_sid", table_name="form")
    op.drop_index("ix_form_slug", table_name="form")
    op.drop_table("form")
    # ### end Alembic commands ###


def downgrade():
    """Downgrade"""
    # ### commands auto generated by Alembic - please adjust! ###
    # Use backup, data is lost with downgrade
    op.create_table(
        "form",
        sa.Column("id", postgresql.UUID(), autoincrement=False, nullable=False),
        sa.Column("name", sa.VARCHAR(length=255), autoincrement=False, nullable=False),
        sa.Column("slug", sa.VARCHAR(length=255), autoincrement=False, nullable=False),
        sa.Column(
            "status",
            postgresql.ENUM("ACTIVE", "INACTIVE", name="status"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("publish_date", sa.DATE(), autoincrement=False, nullable=True),
        sa.Column("sid", sa.INTEGER(), autoincrement=False, nullable=False),
        sa.Column(
            "form",
            postgresql.JSON(),
            autoincrement=False,
            nullable=True,
        ),
        sa.Column(
            "config",
            postgresql.JSON(),
            autoincrement=False,
            nullable=True,
        ),
        sa.Column("public", sa.BOOLEAN(), autoincrement=False, nullable=False),
        sa.Column(
            "creator_organization_uuid",
            postgresql.UUID(),
            autoincrement=False,
            nullable=False,
        ),
        sa.PrimaryKeyConstraint("sid", name="form_pkey"),
        sa.UniqueConstraint(
            "name",
            "creator_organization_uuid",
            name="uc_name_creator_organization_uuid",
        ),
        sa.UniqueConstraint(
            "slug",
            "creator_organization_uuid",
            name="uc_slug_creator_organization_uuid",
        ),
        postgresql_ignore_search_path=False,
    )
    op.create_index("ix_form_slug", "form", ["slug"], unique=False)
    op.create_index("ix_form_sid", "form", ["sid"], unique=False)
    op.create_index("ix_form_name", "form", ["name"], unique=False)
    op.create_index("ix_form_id", "form", ["id"], unique=False)
    op.create_table(
        "shared_with",
        sa.Column("sid", sa.INTEGER(), autoincrement=True, nullable=False),
        sa.Column("form_sid", sa.INTEGER(), autoincrement=False, nullable=False),
        sa.Column(
            "organization_uuid",
            postgresql.UUID(),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column(
            "rights",
            postgresql.ENUM(name="rights", create_type=False),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column(
            "organization_name",
            sa.VARCHAR(),
            autoincrement=False,
            nullable=False,
        ),
        sa.ForeignKeyConstraint(["form_sid"], ["form.sid"], name="shared_with_form_sid_fkey"),
        sa.PrimaryKeyConstraint("sid", name="shared_with_pkey"),
        sa.UniqueConstraint("form_sid", "organization_uuid", name="unique_columns_share_with"),
    )
    op.create_index("ix_shared_with_sid", "shared_with", ["sid"], unique=False)
    op.drop_index(op.f("ix_form_management_slug"), table_name="form_management")
    op.drop_index(op.f("ix_form_management_sid"), table_name="form_management")
    op.drop_index(op.f("ix_form_management_name"), table_name="form_management")
    op.drop_table("form_management")
    op.drop_index(op.f("ix_form_details_sid"), table_name="form_details")
    op.drop_index(op.f("ix_form_details_id"), table_name="form_details")
    op.drop_table("form_details")
    # ### end Alembic commands ###
